unit UnitFergusonGeneral;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFormFergusonGeneral = class(TForm)
    EditExpression: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure EditExpressionKeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormFergusonGeneral: TFormFergusonGeneral;
  //CreationArbre : Boolean;

implementation

{$R *.DFM}

uses UnitPrinc;

function CreeArbre(ch : String;var n :Noeud):Boolean;
var i,j,l : Integer;
    k     : UnOpUnaire;
    p1,p2 : PtNoeud;

function SauteParentheses(var i : Integer;sens : Integer):Boolean;
var np : Integer;
begin
np :=0;
repeat
 case ch[i] of
   '(' : Inc(np);
   ')' : Inc(np,-1);
 end;
Inc(i,sens);
until (np=0) or (i > l) or (i < 1) ;
Inc(i,-sens);
SauteParentheses := (np=0);
end; {function SauteParentheses }

procedure Coupe(c:String;x:UnOpUnaire);
begin
n.typ      := OpUnaire;
n.oper1    := x;
New(p1);
n.gauche   := p1;
CreeArbre := CreeArbre(c,n.gauche^);
end; {procedure Coupe }

procedure CoupeBi(x:UnOpBinaire);
begin
n.typ      := OpBinaire;
n.oper2    := x;
New(p1);
New(p2);
n.gauche := p1;
n.droite := p2;
if not CreeArbre(copy(ch,1,i-1),n.gauche^) then Exit;
if not CreeArbre(copy(ch,i+1,l-i),n.droite^) then Exit;
CreeArbre := True;
end; {procedure CoupeBi }

function Recherche(c1,c2:char; x1,x2:UnOpBinaire):Boolean;
begin
Recherche := False;
i := l;
repeat
  if (ch[i]=')')
    then if not SauteParentheses(i,-1) then
           begin
           Recherche := True;
           Exit;
           end;
  if (ch[i]=c1)
    then if (i>1) and (i<l) and not (ch[i-1] in ['(','*','/','^']) then
           begin
           CoupeBi(x1);
           Recherche := True;
           Exit;
           end;
  if (ch[i]=c2)
    then if (i>1) and (i<l) and not (ch[i-1] in ['(','*','/','^']) then
           begin
           CoupeBi(x2);
           Recherche := True;
           Exit;
           end;
  Inc(i,-1);
until(i<=1);
end; {function recherche }

begin  {fonction CreeArbre}
// ------------  1 : Initialisation  ---------------------------------
CreeArbre := False;
n.typ := cte;
l := length(ch);
if (l=0) then Exit;

// ------------  2 : Recherche des opratuers binaires ----------------
if Recherche('-','+',Fsou,Fsom) then Exit;
if Recherche('/','*',Fdiv,Fmul) then Exit;

// ------------  3 : Recherche du + et - unaires ----------------------
if (ch[1]='-') then
  begin
  Coupe(copy(ch,2,l-1),Fmoins);
  Exit;
  end;
if (ch[1]='+') then
  begin
  Coupe(copy(ch,2,l-1),Fplus);
  Exit;
  end;

if Recherche('^','^',Fpui,Fpui) then Exit;

// ------------  4 : Recherche des parenthses ------------------------
i := 1;
if (ch[1]='(') then
  begin
  if SauteParentheses(i,1) then
    if (i=l) then CreeArbre := CreeArbre(copy(ch,2,l-2),n);
  Exit;
  end;

// ------------  5 : Recherche des oprateurs unaires  ----------------
for k := Fsin to Fsqr do
  begin
  j := length(OperateursUnaires[k]);
  if (operateursUnaires[k] = copy(ch,1,j)) then
    begin
    if (ch[j+1] = '(') then Coupe(copy(ch,j+1,l-j),k);
    Exit;
    end;
  end;

// ------------  6 : Recherche de la variable A C x x0 y --------------
if (ch='A') or (ch='a') then
  begin
  n.typ     := variable;
  n.rang    := 0;
  CreeArbre := True;
  Exit;
  end;
if (ch='C') or (ch='c') then
  begin
  n.typ     := variable;
  n.rang    := 1;
  CreeArbre := True;
  Exit;
  end;
if (ch='x0') then   // attention  l'ordre entre x et x0 : d'abord x0
  begin
  n.typ     := variable;
  n.rang    := 2;
  CreeArbre := True;
  Exit;
  end;
if (ch='y0') then
  begin
  n.typ     := variable;
  n.rang    := 3;
  CreeArbre := True;
  Exit;
  end;
if (ch='x') then
  begin
  n.typ     := variable;
  n.rang    := 4;
  CreeArbre := True;
  Exit;
  end;
if (ch='z0') then
  begin
  n.typ     := variable;
  n.rang    := 5;
  CreeArbre := True;
  Exit;
  end;
if (ch='z') then
  begin
  n.typ     := variable;
  n.rang    := 6;
  CreeArbre := True;
  Exit;
  end;
if (ch='B') or (ch='b') then
  begin
  n.typ     := variable;
  n.rang    := 7;
  CreeArbre := True;
  Exit;
  end;

// ------------  7 : Recherche des constantes prdifinies  ------------

if (ch = 'pi') then
  begin
  n.typ     := cte;
  n.valeur  := 3.14159265358979323846;
  CreeArbre := True;
  Exit;
  end;

// ------------  8 : Recherche des constantes numriques  ------------

j := Ord(ch[1]);
if (ch[1] = '.') or ((j>=48) and (j<=57)) then
  begin
  n.typ := cte;
  n.valeur := StrToFloat(ch);
  CreeArbre := True;
  end;
end; {function CreeArbre }


procedure TFormFergusonGeneral.EditExpressionKeyPress(Sender: TObject;
  var Key: Char);
begin
if (Ord(Key)=13) then
  begin
  UnitPrinc.CreationArbre := CreeArbre(EditExpression.Text,f1);
  if UnitPrinc.CreationArbre then
                             begin
                             Label1.Font.Color := clGreen;
                             Label1.Caption := 'successful';
                             end
                             else
                             begin
                             Label1.Font.Color := clRed;
                             Label1.Caption := 'failure';
                             end;
  end;
end;

end.
